Compare commits

...

6 commits
v1.2.2 ... main

Author SHA1 Message Date
Penelope Gwen
3dbe3a68d0 1.3.3 2024-12-10 15:10:14 -08:00
0de14df9d9 bug fix 2024-05-30 23:19:08 -06:00
e067a9c717 bug fix 2024-05-30 23:17:14 -06:00
52230660d6 bug fix 2024-05-30 23:08:22 -06:00
3f5cd90b44 add ci runner 2024-05-30 22:35:21 -06:00
f744b88a0c codebase overhaul 2024-05-30 22:33:49 -06:00
38 changed files with 645 additions and 1229 deletions

65
.gitlab-ci.yml Normal file
View file

@ -0,0 +1,65 @@
# Is performed before the scripts in the stages step
before_script:
- source /etc/profile
# Defines stages which are to be executed
stages:
- build
- upload
- release
.setup_script: &setup_scripts
- apt-get update
- apt-get -y build-dep .
- apt-get -y install dpkg-dev
.compile: &compile
stage: compile
only:
- tags
script:
- *setup_scripts
- dpkg-buildpackage -b
- mkdir -p ./build/{release,debug}
- find ../ -name "*.deb" -not -name "*dbgsym*" -exec mv {} ./build/release/ \;
# - find ../ -name "*dbgsym*.deb" -exec mv {} ./build/debug/ \;
artifacts:
paths:
- build/release/*
# - build/debug/*
untracked: true
build:
<<: *compile
stage: build
upload:
stage: upload
dependencies:
- build
only:
- tags
script:
- find ./build/release -name "*.deb"
- debs=( $( find ./build/release -name "*.deb" ) )
- assets=""
- for d in ${debs[@]};do
- file=$( basename ${d} )
- url="${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/${CI_PROJECT_NAME}/${CI_COMMIT_TAG}/${file}"
- assets="${assets} --assets-link {\"name\":\"${file}\",\"url\":\"${url}\",\"link_type\":\"other\"} "
- "curl --header \"JOB-TOKEN: $CI_JOB_TOKEN\" --upload-file \"${d}\" \"${url}\""
- done
- echo "ASSETS_ARG=${assets}" >> assets.env
artifacts:
reports:
dotenv: assets.env
release:
stage: release
image: registry.gitlab.com/gitlab-org/release-cli:latest
only:
- tags
script:
- echo "making release!"
- echo ${ASSETS_ARG}
- release-cli create --name "Release ${CI_COMMIT_TAG}" --tag-name "${CI_COMMIT_TAG}" ${ASSETS_ARG}

24
debian/changelog vendored
View file

@ -1,3 +1,27 @@
sapphrc (1.3.3) unstable; urgency=medium
* synchronization now deletes files. be careful!
-- Penelope Gwen <support@pogmom.me> Tue, 10 Dec 2024 15:09:01 -0800
sapphrc (1.3.2) unstable; urgency=medium
* bug fixes
-- Penelope Gwen <support@pogmom.me> Thu, 30 May 2024 23:18:54 -0600
sapphrc (1.3.1) unstable; urgency=medium
* Fixed filelist logic
-- Penelope Gwen <support@pogmom.me> Thu, 30 May 2024 23:07:39 -0600
sapphrc (1.3.0) unstable; urgency=medium
* codebase overhaul
-- Penelope Gwen <support@pogmom.me> Thu, 30 May 2024 20:57:16 -0600
sapphrc (1.2.2) unstable; urgency=medium
* faulty git logic

4
debian/control vendored
View file

@ -13,5 +13,5 @@ Architecture: all
Multi-Arch: foreign
Depends:
${misc:Depends}, git,rsync
Description: dotfiles backup and profiles
<Insert long description, indented with spaces.>
Description: dotfiles backup with profiles
Sapphrc is a dotfiles manager with support for multiple profile and git synchonization

3
debian/install vendored
View file

@ -1,4 +1,5 @@
lib/sapphrc/* lib/sapphrc/
usr/bin/* usr/bin/
usr/share/doc/sapphrc/* usr/share/doc/sapphrc/
lib/sapphrc/* lib/sapphrc/
etc/bash_completion.d/sapphrc etc/bash_completion.d/

56
debian/manpage.1.ex vendored
View file

@ -1,56 +0,0 @@
.\" Hey, EMACS: -*- nroff -*-
.\" (C) Copyright 2024 Penelope Gwen <support@pogmom.me>,
.\"
.\" First parameter, NAME, should be all caps
.\" Second parameter, SECTION, should be 1-8, maybe w/ subsection
.\" other parameters are allowed: see man(7), man(1)
.TH Sapphrc SECTION "March 8 2024"
.\" Please adjust this date whenever revising the manpage.
.\"
.\" Some roff macros, for reference:
.\" .nh disable hyphenation
.\" .hy enable hyphenation
.\" .ad l left justify
.\" .ad b justify to both left and right margins
.\" .nf disable filling
.\" .fi enable filling
.\" .br insert line break
.\" .sp <n> insert n+1 empty lines
.\" for manpage-specific macros, see man(7)
.SH NAME
sapphrc \- program to do something
.SH SYNOPSIS
.B sapphrc
.RI [ options ] " files" ...
.br
.B bar
.RI [ options ] " files" ...
.SH DESCRIPTION
This manual page documents briefly the
.B sapphrc
and
.B bar
commands.
.PP
.\" TeX users may be more comfortable with the \fB<whatever>\fP and
.\" \fI<whatever>\fP escape sequences to invode bold face and italics,
.\" respectively.
\fBsapphrc\fP is a program that...
.SH OPTIONS
These programs follow the usual GNU command line syntax, with long
options starting with two dashes ('\-').
A summary of options is included below.
For a complete description, see the Info files.
.TP
.B \-h, \-\-help
Show summary of options.
.TP
.B \-v, \-\-version
Show version of program.
.SH SEE ALSO
.BR bar (1),
.BR baz (1).
.br
The programs are documented fully by
.IR "The Rise and Fall of a Fooish Bar" ,
available via the Info system.

134
debian/manpage.md.ex vendored
View file

@ -1,134 +0,0 @@
% sapphrc(SECTION) | User Commands
%
% "March 8 2024"
[comment]: # The lines above form a Pandoc metadata block. They must be
[comment]: # the first ones in the file.
[comment]: # See https://pandoc.org/MANUAL.html#metadata-blocks for details.
[comment]: # pandoc -s -f markdown -t man package.md -o package.1
[comment]: #
[comment]: # A manual page package.1 will be generated. You may view the
[comment]: # manual page with: nroff -man package.1 | less. A typical entry
[comment]: # in a Makefile or Makefile.am is:
[comment]: #
[comment]: # package.1: package.md
[comment]: # pandoc --standalone --from=markdown --to=man $< --output=$@
[comment]: #
[comment]: # The pandoc binary is found in the pandoc package. Please remember
[comment]: # that if you create the nroff version in one of the debian/rules
[comment]: # file targets, such as build, you will need to include pandoc in
[comment]: # your Build-Depends control field.
[comment]: # lowdown is a low dependency, lightweight alternative to
[comment]: # pandoc as a markdown to manpage translator. Use with:
[comment]: #
[comment]: # package.1: package.md
[comment]: # lowdown -s -Tman -o $@ $<
[comment]: #
[comment]: # And add lowdown to the Build-Depends control field.
[comment]: # Remove the lines starting with '[comment]:' in this file in order
[comment]: # to avoid warning messages.
# NAME
sapphrc - program to do something
# SYNOPSIS
**sapphrc** **-e** _this_ [**\-\-example=that**] [{**-e** | **\-\-example**} _this_]
[{**-e** | **\-\-example**} {_this_ | _that_}]
**sapphrc** [{**-h** | *\-\-help**} | {**-v** | **\-\-version**}]
# DESCRIPTION
This manual page documents briefly the **sapphrc** and **bar** commands.
This manual page was written for the Debian distribution because the
original program does not have a manual page. Instead, it has documentation
in the GNU info(1) format; see below.
**sapphrc** is a program that...
# OPTIONS
The program follows the usual GNU command line syntax, with long options
starting with two dashes ('-'). A summary of options is included below. For
a complete description, see the **info**(1) files.
**-e** _this_, **\-\-example=**_that_
: Does this and that.
**-h**, **\-\-help**
: Show summary of options.
**-v**, **\-\-version**
: Show version of program.
# FILES
/etc/foo.conf
: The system-wide configuration file to control the behaviour of
sapphrc. See **foo.conf**(5) for further details.
${HOME}/.foo.conf
: The per-user configuration file to control the behaviour of
sapphrc. See **foo.conf**(5) for further details.
# ENVIRONMENT
**FOO_CONF**
: If used, the defined file is used as configuration file (see also
the section called FILES).
# DIAGNOSTICS
The following diagnostics may be issued on stderr:
Bad configuration file. Exiting.
: The configuration file seems to contain a broken configuration
line. Use the **\-\-verbose** option, to get more info.
**sapphrc** provides some return codes, that can be used in scripts:
Code Diagnostic
0 Program exited successfully.
1 The configuration file seems to be broken.
# BUGS
The program is currently limited to only work with the foobar library.
The upstream BTS can be found at http://bugzilla.foo.tld.
# SEE ALSO
**bar**(1), **baz**(1), **foo.conf**(5)
The programs are documented fully by The Rise and Fall of a Fooish Bar
available via the **info**(1) system.
# AUTHOR
Penelope Gwen <support@pogmom.me>
: Wrote this manpage for the Debian system.
# COPYRIGHT
Copyright © 2007 Penelope Gwen
This manual page was written for the Debian system (and may be used by
others).
Permission is granted to copy, distribute and/or modify this document under
the terms of the GNU General Public License, Version 2 or (at your option)
any later version published by the Free Software Foundation.
On Debian systems, the complete text of the GNU General Public License
can be found in /usr/share/common-licenses/GPL.
[comment]: # Local Variables:
[comment]: # mode: markdown
[comment]: # End:

154
debian/manpage.sgml.ex vendored
View file

@ -1,154 +0,0 @@
<!doctype refentry PUBLIC "-//OASIS//DTD DocBook V4.1//EN" [
<!-- Process this file with docbook-to-man to generate an nroff manual
page: 'docbook-to-man manpage.sgml > manpage.1'. You may view
the manual page with: 'docbook-to-man manpage.sgml | nroff -man |
less'. A typical entry in a Makefile or Makefile.am is:
manpage.1: manpage.sgml
docbook-to-man $< > $@
The docbook-to-man binary is found in the docbook-to-man package.
Please remember that if you create the nroff version in one of the
debian/rules file targets (such as build), you will need to include
docbook-to-man in your Build-Depends control field.
-->
<!-- Fill in your name for FIRSTNAME and SURNAME. -->
<!ENTITY dhfirstname "<firstname>FIRSTNAME</firstname>">
<!ENTITY dhsurname "<surname>SURNAME</surname>">
<!-- Please adjust the date whenever revising the manpage. -->
<!ENTITY dhdate "<date>March 8 2024</date>">
<!-- SECTION should be 1-8, maybe w/ subsection other parameters are
allowed: see man(7), man(1). -->
<!ENTITY dhsection "<manvolnum>SECTION</manvolnum>">
<!ENTITY dhemail "<email>support@pogmom.me</email>">
<!ENTITY dhusername "Penelope Gwen">
<!ENTITY dhucpackage "<refentrytitle>Sapphrc</refentrytitle>">
<!ENTITY dhpackage "sapphrc">
<!ENTITY debian "<productname>Debian</productname>">
<!ENTITY gnu "<acronym>GNU</acronym>">
<!ENTITY gpl "&gnu; <acronym>GPL</acronym>">
]>
<refentry>
<refentryinfo>
<address>
&dhemail;
</address>
<author>
&dhfirstname;
&dhsurname;
</author>
<copyright>
<year>2003</year>
<holder>&dhusername;</holder>
</copyright>
&dhdate;
</refentryinfo>
<refmeta>
&dhucpackage;
&dhsection;
</refmeta>
<refnamediv>
<refname>&dhpackage;</refname>
<refpurpose>program to do something</refpurpose>
</refnamediv>
<refsynopsisdiv>
<cmdsynopsis>
<command>&dhpackage;</command>
<arg><option>-e <replaceable>this</replaceable></option></arg>
<arg><option>--example <replaceable>that</replaceable></option></arg>
</cmdsynopsis>
</refsynopsisdiv>
<refsect1>
<title>DESCRIPTION</title>
<para>This manual page documents briefly the
<command>&dhpackage;</command> and <command>bar</command>
commands.</para>
<para>This manual page was written for the &debian; distribution
because the original program does not have a manual page.
Instead, it has documentation in the &gnu;
<application>Info</application> format; see below.</para>
<para><command>&dhpackage;</command> is a program that...</para>
</refsect1>
<refsect1>
<title>OPTIONS</title>
<para>These programs follow the usual &gnu; command line syntax,
with long options starting with two dashes ('-'). A summary of
options is included below. For a complete description, see the
<application>Info</application> files.</para>
<variablelist>
<varlistentry>
<term><option>-h</option>
<option>--help</option>
</term>
<listitem>
<para>Show summary of options.</para>
</listitem>
</varlistentry>
<varlistentry>
<term><option>-v</option>
<option>--version</option>
</term>
<listitem>
<para>Show version of program.</para>
</listitem>
</varlistentry>
</variablelist>
</refsect1>
<refsect1>
<title>SEE ALSO</title>
<para>bar (1), baz (1).</para>
<para>The programs are documented fully by <citetitle>The Rise and
Fall of a Fooish Bar</citetitle> available via the
<application>Info</application> system.</para>
</refsect1>
<refsect1>
<title>AUTHOR</title>
<para>This manual page was written by &dhusername; &dhemail; for
the &debian; system (and may be used by others). Permission is
granted to copy, distribute and/or modify this document under
the terms of the &gnu; General Public License, Version 2 any
later version published by the Free Software Foundation.
</para>
<para>
On Debian systems, the complete text of the GNU General Public
License can be found in /usr/share/common-licenses/GPL.
</para>
</refsect1>
</refentry>
<!-- Keep this comment at the end of the file
Local variables:
mode: sgml
sgml-omittag:t
sgml-shorttag:t
sgml-minimize-attributes:nil
sgml-always-quote-attributes:t
sgml-indent-step:2
sgml-indent-data:t
sgml-parent-document:nil
sgml-default-dtd-file:nil
sgml-exposed-tags:nil
sgml-local-catalogs:nil
sgml-local-ecat-files:nil
End:
-->

291
debian/manpage.xml.ex vendored
View file

@ -1,291 +0,0 @@
<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
<!--
`xsltproc -''-nonet \
-''-param man.charmap.use.subset "0" \
-''-param make.year.ranges "1" \
-''-param make.single.year.ranges "1" \
/usr/share/xml/docbook/stylesheet/docbook-xsl/manpages/docbook.xsl \
manpage.xml`
A manual page <package>.<section> will be generated. You may view the
manual page with: nroff -man <package>.<section> | less'. A typical entry
in a Makefile or Makefile.am is:
DB2MAN = /usr/share/sgml/docbook/stylesheet/xsl/docbook-xsl/manpages/docbook.xsl
XP = xsltproc -''-nonet -''-param man.charmap.use.subset "0"
manpage.1: manpage.xml
$(XP) $(DB2MAN) $<
The xsltproc binary is found in the xsltproc package. The XSL files are in
docbook-xsl. A description of the parameters you can use can be found in the
docbook-xsl-doc-* packages. Please remember that if you create the nroff
version in one of the debian/rules file targets (such as build), you will need
to include xsltproc and docbook-xsl in your Build-Depends control field.
Alternatively use the xmlto command/package. That will also automatically
pull in xsltproc and docbook-xsl.
Notes for using docbook2x: docbook2x-man does not automatically create the
AUTHOR(S) and COPYRIGHT sections. In this case, please add them manually as
<refsect1> ... </refsect1>.
To disable the automatic creation of the AUTHOR(S) and COPYRIGHT sections
read /usr/share/doc/docbook-xsl/doc/manpages/authors.html. This file can be
found in the docbook-xsl-doc-html package.
Validation can be done using: `xmllint -''-noout -''-valid manpage.xml`
General documentation about man-pages and man-page-formatting:
man(1), man(7), http://www.tldp.org/HOWTO/Man-Page/
-->
<!-- Fill in your name for FIRSTNAME and SURNAME. -->
<!ENTITY dhfirstname "FIRSTNAME">
<!ENTITY dhsurname "SURNAME">
<!-- dhusername could also be set to "&dhfirstname; &dhsurname;". -->
<!ENTITY dhusername "Penelope Gwen">
<!ENTITY dhemail "support@pogmom.me">
<!-- SECTION should be 1-8, maybe w/ subsection other parameters are
allowed: see man(7), man(1) and
http://www.tldp.org/HOWTO/Man-Page/q2.html. -->
<!ENTITY dhsection "SECTION">
<!-- TITLE should be something like "User commands" or similar (see
http://www.tldp.org/HOWTO/Man-Page/q2.html). -->
<!ENTITY dhtitle "sapphrc User Manual">
<!ENTITY dhucpackage "Sapphrc">
<!ENTITY dhpackage "sapphrc">
]>
<refentry>
<refentryinfo>
<title>&dhtitle;</title>
<productname>&dhpackage;</productname>
<authorgroup>
<author>
<firstname>&dhfirstname;</firstname>
<surname>&dhsurname;</surname>
<contrib>Wrote this manpage for the Debian system.</contrib>
<address>
<email>&dhemail;</email>
</address>
</author>
</authorgroup>
<copyright>
<year>2007</year>
<holder>&dhusername;</holder>
</copyright>
<legalnotice>
<para>This manual page was written for the Debian system
(and may be used by others).</para>
<para>Permission is granted to copy, distribute and/or modify this
document under the terms of the GNU General Public License,
Version 2 or (at your option) any later version published by
the Free Software Foundation.</para>
<para>On Debian systems, the complete text of the GNU General Public
License can be found in
<filename>/usr/share/common-licenses/GPL</filename>.</para>
</legalnotice>
</refentryinfo>
<refmeta>
<refentrytitle>&dhucpackage;</refentrytitle>
<manvolnum>&dhsection;</manvolnum>
</refmeta>
<refnamediv>
<refname>&dhpackage;</refname>
<refpurpose>program to do something</refpurpose>
</refnamediv>
<refsynopsisdiv>
<cmdsynopsis>
<command>&dhpackage;</command>
<!-- These are several examples, how syntaxes could look -->
<arg choice="plain"><option>-e <replaceable>this</replaceable></option></arg>
<arg choice="opt"><option>--example=<parameter>that</parameter></option></arg>
<arg choice="opt">
<group choice="req">
<arg choice="plain"><option>-e</option></arg>
<arg choice="plain"><option>--example</option></arg>
</group>
<replaceable class="option">this</replaceable>
</arg>
<arg choice="opt">
<group choice="req">
<arg choice="plain"><option>-e</option></arg>
<arg choice="plain"><option>--example</option></arg>
</group>
<group choice="req">
<arg choice="plain"><replaceable>this</replaceable></arg>
<arg choice="plain"><replaceable>that</replaceable></arg>
</group>
</arg>
</cmdsynopsis>
<cmdsynopsis>
<command>&dhpackage;</command>
<!-- Normally the help and version options make the programs stop
right after outputting the requested information. -->
<group choice="opt">
<arg choice="plain">
<group choice="req">
<arg choice="plain"><option>-h</option></arg>
<arg choice="plain"><option>--help</option></arg>
</group>
</arg>
<arg choice="plain">
<group choice="req">
<arg choice="plain"><option>-v</option></arg>
<arg choice="plain"><option>--version</option></arg>
</group>
</arg>
</group>
</cmdsynopsis>
</refsynopsisdiv>
<refsect1 id="description">
<title>DESCRIPTION</title>
<para>This manual page documents briefly the
<command>&dhpackage;</command> and <command>bar</command>
commands.</para>
<para>This manual page was written for the Debian distribution
because the original program does not have a manual page.
Instead, it has documentation in the GNU <citerefentry>
<refentrytitle>info</refentrytitle>
<manvolnum>1</manvolnum>
</citerefentry> format; see below.</para>
<para><command>&dhpackage;</command> is a program that...</para>
</refsect1>
<refsect1 id="options">
<title>OPTIONS</title>
<para>The program follows the usual GNU command line syntax,
with long options starting with two dashes ('-'). A summary of
options is included below. For a complete description, see the
<citerefentry>
<refentrytitle>info</refentrytitle>
<manvolnum>1</manvolnum>
</citerefentry> files.</para>
<variablelist>
<!-- Use the variablelist.term.separator and the
variablelist.term.break.after parameters to
control the term elements. -->
<varlistentry>
<term><option>-e <replaceable>this</replaceable></option></term>
<term><option>--example=<replaceable>that</replaceable></option></term>
<listitem>
<para>Does this and that.</para>
</listitem>
</varlistentry>
<varlistentry>
<term><option>-h</option></term>
<term><option>--help</option></term>
<listitem>
<para>Show summary of options.</para>
</listitem>
</varlistentry>
<varlistentry>
<term><option>-v</option></term>
<term><option>--version</option></term>
<listitem>
<para>Show version of program.</para>
</listitem>
</varlistentry>
</variablelist>
</refsect1>
<refsect1 id="files">
<title>FILES</title>
<variablelist>
<varlistentry>
<term><filename>/etc/foo.conf</filename></term>
<listitem>
<para>The system-wide configuration file to control the
behaviour of <application>&dhpackage;</application>. See
<citerefentry>
<refentrytitle>foo.conf</refentrytitle>
<manvolnum>5</manvolnum>
</citerefentry> for further details.</para>
</listitem>
</varlistentry>
<varlistentry>
<term><filename>${HOME}/.foo.conf</filename></term>
<listitem>
<para>The per-user configuration file to control the
behaviour of <application>&dhpackage;</application>. See
<citerefentry>
<refentrytitle>foo.conf</refentrytitle>
<manvolnum>5</manvolnum>
</citerefentry> for further details.</para>
</listitem>
</varlistentry>
</variablelist>
</refsect1>
<refsect1 id="environment">
<title>ENVIRONMENT</title>
<variablelist>
<varlistentry>
<term><envar>FOO_CONF</envar></term>
<listitem>
<para>If used, the defined file is used as configuration
file (see also <xref linkend="files"/>).</para>
</listitem>
</varlistentry>
</variablelist>
</refsect1>
<refsect1 id="diagnostics">
<title>DIAGNOSTICS</title>
<para>The following diagnostics may be issued
on <filename class="devicefile">stderr</filename>:</para>
<variablelist>
<varlistentry>
<term><errortext>Bad configuration file. Exiting.</errortext></term>
<listitem>
<para>The configuration file seems to contain a broken configuration
line. Use the <option>--verbose</option> option, to get more info.
</para>
</listitem>
</varlistentry>
</variablelist>
<para><command>&dhpackage;</command> provides some return codes, that can
be used in scripts:</para>
<segmentedlist>
<segtitle>Code</segtitle>
<segtitle>Diagnostic</segtitle>
<seglistitem>
<seg><errorcode>0</errorcode></seg>
<seg>Program exited successfully.</seg>
</seglistitem>
<seglistitem>
<seg><errorcode>1</errorcode></seg>
<seg>The configuration file seems to be broken.</seg>
</seglistitem>
</segmentedlist>
</refsect1>
<refsect1 id="bugs">
<!-- Or use this section to tell about upstream BTS. -->
<title>BUGS</title>
<para>The program is currently limited to only work
with the <package>foobar</package> library.</para>
<para>The upstreams <acronym>BTS</acronym> can be found
at <ulink url="http://bugzilla.foo.tld"/>.</para>
</refsect1>
<refsect1 id="see_also">
<title>SEE ALSO</title>
<!-- In alpabetical order. -->
<para><citerefentry>
<refentrytitle>bar</refentrytitle>
<manvolnum>1</manvolnum>
</citerefentry>, <citerefentry>
<refentrytitle>baz</refentrytitle>
<manvolnum>1</manvolnum>
</citerefentry>, <citerefentry>
<refentrytitle>foo.conf</refentrytitle>
<manvolnum>5</manvolnum>
</citerefentry></para>
<para>The programs are documented fully by <citetitle>The Rise and
Fall of a Fooish Bar</citetitle> available via the <citerefentry>
<refentrytitle>info</refentrytitle>
<manvolnum>1</manvolnum>
</citerefentry> system.</para>
</refsect1>
</refentry>

39
debian/postinst.ex vendored
View file

@ -1,39 +0,0 @@
#!/bin/sh
# postinst script for sapphrc.
#
# See: dh_installdeb(1).
set -e
# Summary of how this script can be called:
# * <postinst> 'configure' <most-recently-configured-version>
# * <old-postinst> 'abort-upgrade' <new version>
# * <conflictor's-postinst> 'abort-remove' 'in-favour' <package>
# <new-version>
# * <postinst> 'abort-remove'
# * <deconfigured's-postinst> 'abort-deconfigure' 'in-favour'
# <failed-install-package> <version> 'removing'
# <conflicting-package> <version>
# for details, see https://www.debian.org/doc/debian-policy/ or
# the debian-policy package.
case "$1" in
configure)
;;
abort-upgrade|abort-remove|abort-deconfigure)
;;
*)
echo "postinst called with unknown argument '$1'" >&2
exit 1
;;
esac
# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.
#DEBHELPER#
exit 0

37
debian/postrm.ex vendored
View file

@ -1,37 +0,0 @@
#!/bin/sh
# postrm script for sapphrc.
#
# See: dh_installdeb(1).
set -e
# Summary of how this script can be called:
# * <postrm> 'remove'
# * <postrm> 'purge'
# * <old-postrm> 'upgrade' <new-version>
# * <new-postrm> 'failed-upgrade' <old-version>
# * <new-postrm> 'abort-install'
# * <new-postrm> 'abort-install' <old-version>
# * <new-postrm> 'abort-upgrade' <old-version>
# * <disappearer's-postrm> 'disappear' <overwriter>
# <overwriter-version>
# for details, see https://www.debian.org/doc/debian-policy/ or
# the debian-policy package.
case "$1" in
purge|remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
;;
*)
echo "postrm called with unknown argument '$1'" >&2
exit 1
;;
esac
# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.
#DEBHELPER#
exit 0

35
debian/preinst.ex vendored
View file

@ -1,35 +0,0 @@
#!/bin/sh
# preinst script for sapphrc.
#
# See: dh_installdeb(1).
set -e
# Summary of how this script can be called:
# * <new-preinst> 'install'
# * <new-preinst> 'install' <old-version>
# * <new-preinst> 'upgrade' <old-version>
# * <old-preinst> 'abort-upgrade' <new-version>
# for details, see https://www.debian.org/doc/debian-policy/ or
# the debian-policy package.
case "$1" in
install|upgrade)
;;
abort-upgrade)
;;
*)
echo "preinst called with unknown argument '$1'" >&2
exit 1
;;
esac
# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.
#DEBHELPER#
exit 0

38
debian/prerm.ex vendored
View file

@ -1,38 +0,0 @@
#!/bin/sh
# prerm script for sapphrc.
#
# See: dh_installdeb(1).
set -e
# Summary of how this script can be called:
# * <prerm> 'remove'
# * <old-prerm> 'upgrade' <new-version>
# * <new-prerm> 'failed-upgrade' <old-version>
# * <conflictor's-prerm> 'remove' 'in-favour' <package> <new-version>
# * <deconfigured's-prerm> 'deconfigure' 'in-favour'
# <package-being-installed> <version> 'removing'
# <conflicting-package> <version>
# for details, see https://www.debian.org/doc/debian-policy/ or
# the debian-policy package.
case "$1" in
remove|upgrade|deconfigure)
;;
failed-upgrade)
;;
*)
echo "prerm called with unknown argument '$1'" >&2
exit 1
;;
esac
# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.
#DEBHELPER#
exit 0

View file

@ -1,10 +0,0 @@
# For more information on what jobs are run see:
# https://salsa.debian.org/salsa-ci-team/pipeline
#
# To enable the jobs, go to your repository (at salsa.debian.org)
# and click over Settings > CI/CD > Expand (in General pipelines).
# In "CI/CD configuration file" write debian/salsa-ci.yml and click
# in "Save Changes". The CI tests will run after the next commit.
---
include:
- https://salsa.debian.org/salsa-ci-team/pipeline/raw/master/recipes/debian.yml

View file

@ -1,4 +0,0 @@
#
# Regular cron jobs for the sapphrc package.
#
0 4 * * * root [ -x /usr/bin/sapphrc_maintenance ] && /usr/bin/sapphrc_maintenance

View file

@ -1,20 +0,0 @@
Document: sapphrc
Title: Debian sapphrc Manual
Author: <insert document author here>
Abstract: This manual describes what sapphrc is
and how it can be used to
manage online manuals on Debian systems.
Section: unknown
Format: debiandoc-sgml
Files: /usr/share/doc/sapphrc/sapphrc.sgml.gz
Format: postscript
Files: /usr/share/doc/sapphrc/sapphrc.ps.gz
Format: text
Files: /usr/share/doc/sapphrc/sapphrc.text.gz
Format: HTML
Index: /usr/share/doc/sapphrc/html/index.html
Files: /usr/share/doc/sapphrc/html/*.html

View file

@ -0,0 +1,20 @@
#/usr/bin/env bash
_sapphrc(){
COMPREPLY=()
cur="${COMP_WORDS[COMP_CWORD]}"
prev="${COMP_WORDS[COMP_CWORD-1]}"
if [[ ${prev} == sapphrc ]]; then
COMPREPLY=( $(compgen -W "setup profile backup restore sync include exclude" -- ${cur}) )
return 0
elif [[ ${prev} == *clude ]]; then
COMPREPLY=( $(compgen -W "add remove" -- ${cur}) )
elif [[ ${prev} == profile ]]; then
COMPREPLY=( $(compgen -W "create remove join leave list" -- ${cur}) )
elif [[ ${prev} == -p ]] || [[ ${prev} == leave ]] || [[ ${prev} == join ]] || [[ ${prev} == remove ]]; then
COMPREPLY=( $(compgen -W "$(ls ~/.config/sapphrc/backups)" -- ${cur}) )
elif [[ ${prev} == add ]]; then
COMPREPLY=( $(compgen -f ${cur}) )
fi
}
complete -F _sapphrc sapphrc

View file

@ -0,0 +1,95 @@
#!/bin/bash
sapphrc_addfile(){
[ ${#@} -eq 0 ] && echo "No files selected" && exit 1
for file in "$@";do
fullpath=$(realpath "${file}")
if ! [[ "$fullpath" =~ ^"$HOME/".* ]];then
echo "file not in home dir"
break
fi
if ! [[ -d "$file" || -f "$file" ]];then
echo "file does not exist"
break
fi
filelist+=(${fullpath#$HOME/})
done
for e in ${filelist[@]};do
echo $e
done
read -p "${bold}Add the listed files/directories to profile '${PROFILE_NAME}'?${normal} (Y/n)" yn
if ! [[ "${yn}" =~ ^([nN][oO]|[nN])$ ]];then
for e in ${filelist[@]};do
if grep -q ^"${e}"$ "${sapphrc_config}/backups/${PROFILE_NAME}/${LIST}";then
echo "already in file"
else
echo $e|tee -a "${sapphrc_config}/backups/${PROFILE_NAME}/${LIST}" >/dev/null
fi
done
fi
}
sapphrc_rmfile(){
i=0
while read line; do
rmfiles+=("$i");i=$(($i+1))
rmfiles+=("$line")
rmfiles+=("$line")
done < "${sapphrc_config}/backups/${PROFILE_NAME}/${LIST}"
[ ${#rmfiles[@]} -eq 0 ] && echo "No files in list" && exit 1
choices=($(dialog --checklist --output-fd 1 "Select options:" 0 0 0 "${rmfiles[@]}"))
if [ $? -ne 0 ]; then
echo "User canceled."
exit 1
fi
for choice in "${choices[@]}"; do
rmlines="${rmlines}$((${choice}+1))d;"
done
sed -i "${rmlines}" "${sapphrc_config}/backups/${PROFILE_NAME}/${LIST}"
echo "Removed ${#choices[@]} paths from ${PROFILE_NAME} ${LIST} list"
}
sapphrc_filelists(){
case "$1" in
include|exclude)
LIST="$1"
shift 1;;
*)
usage 1;;
esac
case "$1" in
add|remove)
OPERATION="$1"
shift 1;;
*)
usage 1;;
esac
while getopts 'hp:' flag; do
case "${flag}" in
p ) shift 2;PROFILE_NAME="${OPTARG}";;&
h ) usage 1 ;;
esac
done
validate_backupdir
validate_profile "${PROFILE_NAME}"
case "${OPERATION}" in
add)
echo "add"
sapphrc_addfile $@
;;
remove)
echo "remove"
sapphrc_rmfile $@
;;
*)
usage 1;;
esac
echo "$@"
}

View file

@ -1,12 +1,27 @@
#!/bin/bash
source /lib/sapphrc/sapphrc-font
sapphrc_config="$HOME/.config/sapphrc"
usage(){
echo -n "sapphrc "
cat /usr/share/doc/sapphrc/$(basename $0)
echo "sapphrc v${VERSION}"
cat /usr/share/doc/sapphrc/sapphrc
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_setup
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_profile
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_backup
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_restore
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_sync
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_filelists
if [[ "${1}" -eq "1" ]];then
exit 1
fi
}
#usage(){
# echo -n "sapphrc "
# cat /usr/share/doc/sapphrc/$(basename $0)
#}
check_name(){
if [ -z "${1}" ];then
$2 || echo "Profile name cannot be blank"
@ -20,81 +35,27 @@ check_name(){
}
validate_profile(){
profile_name="${1}"
PROFILE_NAME="${1}"
first_check=true
while check_name "${profile_name}" "$first_check";do
while check_name "${PROFILE_NAME}" "$first_check";do
first_check=false
if [ "$COMMAND" == "create" ];then
read -p "Profile Name: " profile_name
read -p "Profile Name: " PROFILE_NAME
else
backups=( "${sapphrc_config}/backups/"* )
echo "$backups"
if [ -d "${backups[0]}" ];then
select d in $(ls "${sapphrc_config}/backups/");do test -n "$d" && break; echo ">>> Invalid Selection"; done
profile_name="$d"
PROFILE_NAME="$d"
else
echo "No backups exist!"
exit 1
fi
fi
done
sapphrc_profile="${sapphrc_config}/backups/${profile_name}"
sapphrc_profile="${sapphrc_config}/backups/${PROFILE_NAME}"
sapphrc_profile_rcdir="${sapphrc_profile}/home/.sapphrc"
sapphrc_profile_rc="${sapphrc_profile_rcdir}/${profile_name}"
}
inex_func(){
validate_profile "${profile_name}"
[ ${#@} -eq 0 ] && echo "No files selected" && exit 1
for file in "$@";do
fullpath=$(realpath "${file}")
if ! [[ "$fullpath" =~ ^"$HOME/".* ]];then
echo "file not in home dir"
break
fi
if ! [[ -d "$file" || -f "$file" ]];then
echo "file does not exist"
break
fi
filelist+=(${fullpath#$HOME/})
done
for e in ${filelist[@]};do
echo $e
done
read -p "${bold}Add the listed files/directories to profile '${profile_name}'?${normal} (Y/n)" yn
if ! [[ "${yn}" =~ ^([nN][oO]|[nN])$ ]];then
for e in ${filelist[@]};do
if grep -q ^"${e}"$ "${sapphrc_config}/backups/${profile_name}/${inex}";then
echo "already in file"
else
echo $e|tee -a "${sapphrc_config}/backups/${profile_name}/${inex}" >/dev/null
fi
done
fi
}
inex_rm(){
validate_profile "${profile_name}"
i=0
while read line; do
rmfiles+=("$i");i=$(($i+1))
rmfiles+=("$line")
rmfiles+=("$line")
done < "${sapphrc_config}/backups/${profile_name}/${inex}"
[ ${#rmfiles[@]} -eq 0 ] && echo "No files in list" && exit 1
choices=($(dialog --checklist --output-fd 1 "Select options:" 0 0 0 "${rmfiles[@]}"))
if [ $? -ne 0 ]; then
echo "User canceled."
exit 1
fi
for choice in "${choices[@]}"; do
rmlines="${rmlines}$((${choice}+1))d;"
done
sed -i "${rmlines}" "${sapphrc_config}/backups/${profile_name}/${inex}"
echo "Removed ${#choices[@]} paths from ${profile_name} ${inex} list"
sapphrc_profile_rc="${sapphrc_profile_rcdir}/${PROFILE_NAME}"
}
validate_backupdir(){
@ -105,3 +66,159 @@ validate_backupdir(){
exit 1
fi
}
#sapphrc_addfile(){
# [ ${#@} -eq 0 ] && echo "No files selected" && exit 1
# for file in "$@";do
# fullpath=$(realpath "${file}")
# if ! [[ "$fullpath" =~ ^"$HOME/".* ]];then
# echo "file not in home dir"
# break
# fi
# if ! [[ -d "$file" || -f "$file" ]];then
# echo "file does not exist"
# break
# fi
# filelist+=(${fullpath#$HOME/})
# done
# for e in ${filelist[@]};do
# echo $e
# done
# read -p "${bold}Add the listed files/directories to profile '${PROFILE_NAME}'?${normal} (Y/n)" yn
# if ! [[ "${yn}" =~ ^([nN][oO]|[nN])$ ]];then
# for e in ${filelist[@]};do
# if grep -q ^"${e}"$ "${sapphrc_config}/backups/${PROFILE_NAME}/${inex}";then
# echo "already in file"
# else
# echo $e|tee -a "${sapphrc_config}/backups/${PROFILE_NAME}/${inex}" >/dev/null
# fi
# done
# fi
#}
#sapphrc_rmfile(){
# i=0
# while read line; do
# rmfiles+=("$i");i=$(($i+1))
# rmfiles+=("$line")
# rmfiles+=("$line")
# done < "${sapphrc_config}/backups/${PROFILE_NAME}/${inex}"
# [ ${#rmfiles[@]} -eq 0 ] && echo "No files in list" && exit 1
# choices=($(dialog --checklist --output-fd 1 "Select options:" 0 0 0 "${rmfiles[@]}"))
# if [ $? -ne 0 ]; then
# echo "User canceled."
# exit 1
# fi
# for choice in "${choices[@]}"; do
# rmlines="${rmlines}$((${choice}+1))d;"
# done
# sed -i "${rmlines}" "${sapphrc_config}/backups/${PROFILE_NAME}/${inex}"
# echo "Removed ${#choices[@]} paths from ${PROFILE_NAME} ${inex} list"
#}
#sapphrc_filelists(){
# case "$1" in
# include|exclude)
# LIST="$1"
# shift 1;;
# *)
# usage 1;;
# esac
# case "$1" in
# add|remove)
# OPERATION="$1"
# shift 1;;
# *)
# usage 1;;
# esac
# while getopts 'hp:' flag; do
# case "${flag}" in
# p ) shift 2;PROFILE_NAME="${OPTARG}";;&
# h ) usage 1 ;;
# esac
# done
# validate_backupdir
# validate_profile "${PROFILE}"
# case "${OPERATION}" in
# add)
# echo "add"
# sapphrc_addfile $@
# ;;
# remove)
# echo "remove"
# sapphrc_rmfile $@
# ;;
# *)
# usage 1;;
# esac
# echo "$@"
#}
#sapphrc_sync(){
# validate_backupdir
# sync_direction="$1"
# cat "${sapphrc_config}/active_profiles" | while read profile_name
# do
# backup_homedir="$sapphrc_config/backups/${profile_name}/home"
# include_list="$sapphrc_config/backups/${profile_name}/include"
# exclude_list="$sapphrc_config/backups/${profile_name}/exclude"
# case ${sync_direction} in
# backup)
# echo "backup"
# rsync -arvSH --files-from="${include_list}" --exclude-from="${exclude_list}" --exclude '.config/sapphrc/' "${HOME}" "${backup_homedir}"
# ;;
# restore)
# echo "restore"
# rsync -arvSH --files-from="${include_list}" --exclude-from="${exclude_list}" --exclude '.config/sapphrc/' "${backup_homedir}" "${HOME}"
# ;;
# *)
# echo "unknown sync direction"
# esac
# done
#}
#sapphrc_backup(){
# sapphrc_sync backup
# find ${HOME}/.config/sapphrc/backups/ -name *.swp -type f -exec rm {} \;
#}
#sapphrc_push(){
# cd "$HOME/.config/sapphrc/backups"
# git add .;
# git add -u;
# git commit -m "New backup `date +'%Y-%m-%d %H:%M:%S'`";
# git push origin main
#}
#sapphrc_restore(){
# validate_backupdir
# cd "$HOME/.config/sapphrc/backups"
# git config pull.rebase false
# git pull --no-edit
# sapphrc_sync restore
#}
#sapphrc_updown(){
# validate_backupdir
# sapphrc_backup
# cd "$HOME/.config/sapphrc/backups"
# gs="$(git status | grep -i 'modified')"
# git fetch origin
# reslog=$(git log HEAD..origin/main --oneline)
# if [[ "${reslog}" != "" ]];then
# #remote changes exist
# sapphrc_restore
# fi
# sapphrc_push
#}

View file

@ -0,0 +1,79 @@
#!/bin/bash
sapphrc_pcreate(){
mkdir -p "${sapphrc_profile_rcdir}"
touch "${sapphrc_profile}/"{include,exclude}
echo '#!/bin/bash'|tee "${sapphrc_profile_rc}" > /dev/null
echo ".sapphrc/${PROFILE_NAME}"|tee "${sapphrc_profile}/include" > /dev/null
chmod +x "${sapphrc_profile_rc}"
echo "Successfully created '${PROFILE_NAME}'"
sapphrc_join "${PROFILE_NAME}"
}
sapphrc_premove(){
echo "WARNING: really remove profile '${PROFILE_NAME}'?"
echo "~${sapphrc_profile#$HOME} and all its contents will be deleted!"
read -p "Confirm removal (y/N): " confirm_remove
if [[ "${confirm_remove}" =~ ^([yY][eE][sS]|[yY])$ ]];then
sapphrc_pleave
echo "removing '${PROFILE_NAME}'"
rm -r "${sapphrc_profile}"
echo "Profile '${PROFILE_NAME}' has been removed. Be sure to leave the profile on other machines/accounts to avoid synchronization issues."
fi
}
sapphrc_pjoin(){
if grep -q ^"${PROFILE_NAME}"$ "${sapphrc_config}/active_profiles";then
echo "Already joined ${PROFILE_NAME}, nothing to do."
else
echo "${PROFILE_NAME}"|tee -a "${sapphrc_config}/active_profiles" > /dev/null
echo "Successfully joined '${PROFILE_NAME}'!"
fi
}
sapphrc_pleave(){
if grep -q ^"${PROFILE_NAME}"$ "${sapphrc_config}/active_profiles";then
sed -i '/^'"${PROFILE_NAME}"'$/d' "${sapphrc_config}/active_profiles"
[ -e "${HOME}/.sapphrc/${PROFILE_NAME}" ] && rm "${HOME}/.sapphrc/${PROFILE_NAME}"
echo "Successfully left '${PROFILE_NAME}'!"
else
echo "You have not joined '${PROFILE_NAME}', nothing to do."
fi
}
sapphrc_plist(){
echo "${bold}Active profiles:${normal}"
cat "${sapphrc_config}/active_profiles"
echo "${bold}Available profiles:${normal}"
ls "${sapphrc_config}/backups/" | cat
}
sapphrc_profile(){
PROFILE_ACTION="${1}"
case "$PROFILE_ACTION" in
create|remove|join|leave)
validate_backupdir
shift 1
validate_profile $@
;;&
create)
sapphrc_pcreate $@
;;
remove)
sapphrc_premove $@
;;
join)
sapphrc_pjoin $@
;;
leave)
sapphrc_pleave $@
;;
list)
sapphrc_plist
;;
*|usage)
usage
;;
esac
}

65
lib/sapphrc/sapphrc-setup Normal file
View file

@ -0,0 +1,65 @@
#!/bin/bash
sapphrc_setup(){
if [ -f "${aspphic_config}/backups/.init_complete" ];then
echo "already setup"
exit 0
fi
mkdir -p "${sapphrc_config}"
mkdir -p "${HOME}/.sapphrc"
while true;do
read -p "pull from an existing backup repo? (y/n) " gitrepo_exists
case $gitrepo_exists in
[Yy] )
read -p "Enter YOUR git repo url: " git_url
git clone "${git_url}" "${sapphrc_config}/backups"
touch "${sapphrc_config}/backups/.init_complete"
backup_count="0"
backups=($(ls "${sapphrc_config}/backups/"))
for b in ${backups[@]};do
[ -d "${sapphrc_config}/backups/${b}" ] && backup_count=$(($backup_count+1))
done
if [[ backup_count -gt 0 ]];then
read -p "Found existing profile(s). Join one? (Y/n) " yn
[[ "${yn}" =~ ^([nN][oO]|[nN])$ ]] || sapphrc profile join
else
sapphrc profile create default
fi
break
;;
[Nn] )
mkdir -p "${sapphrc_config}/backups"
cd "${sapphrc_config}/backups"
git init
touch "${sapphrc_config}/backups/.init_complete"
git add .
git commit -m "first commit"
git branch -M main
read -p "Enter YOUR git repo url: " git_url
git remote add origin "${git_url}"
git push -u origin main
break
;;
esac
done
sapphrc_bashrc="$(awk '/.sapphrc/,/done/' ~/.bashrc)"
if [[ "${#sapphrc_bashrc}" -eq 0 ]];then
echo "for file in ~/.sapphrc/* ; do" >> $HOME/.bashrc
echo " if [ -f \""'$file'"\" ] ; then" >> $HOME/.bashrc
echo " source \""'$file'"\"" >> $HOME/.bashrc
echo " fi" >> $HOME/.bashrc
echo "done" >> $HOME/.bashrc
fi
if [ ! "$(crontab -l | grep -i 'sapphrc sync')" ];then
mkdir -p $HOME/.cache/sapphrc/
crontab -l > $HOME/.cache/sapphrc/crontab
echo '*/15 * * * * sapphrc sync >/dev/null 2>&1' >> $HOME/.cache/sapphrc/crontab
crontab $HOME/.cache/sapphrc/crontab
rm $HOME/.cache/sapphrc/crontab
fi
}

68
lib/sapphrc/sapphrc-sync Normal file
View file

@ -0,0 +1,68 @@
#!/bin/bash
sapphrc_rsync(){
echo ""
# validate_backupdir
sync_direction="$1"
cat "${sapphrc_config}/active_profiles" | while read PROFILE_NAME
do
backup_homedir="$sapphrc_config/backups/${PROFILE_NAME}/home"
include_list="$sapphrc_config/backups/${PROFILE_NAME}/include"
exclude_list="$sapphrc_config/backups/${PROFILE_NAME}/exclude"
case ${sync_direction} in
backup)
echo "backup"
rsync -arvSH --files-from="${include_list}" --exclude-from="${exclude_list}" --exclude '.config/sapphrc/' "${HOME}" "${backup_homedir}" --delete
;;
restore)
echo "restore"
rsync -arvSH --files-from="${include_list}" --exclude-from="${exclude_list}" --exclude '.config/sapphrc/' "${backup_homedir}" "${HOME}" --delete
;;
*)
echo "unknown sync direction"
esac
done
}
sapphrc_backup(){
echo "backing up!"
sapphrc_rsync backup
find ${HOME}/.config/sapphrc/backups/ -name *.swp -type f -exec rm {} \;
}
sapphrc_push(){
echo "pushing!"
cd "$HOME/.config/sapphrc/backups"
git add .;
git add -u;
git commit -m "New backup `date +'%Y-%m-%d %H:%M:%S'`";
git push origin main
}
sapphrc_restore(){
echo "restoring!"
validate_backupdir
cd "$HOME/.config/sapphrc/backups"
git config pull.rebase false
git pull --no-edit
sapphrc_rsync restore
}
sapphrc_sync(){
echo "syncing!"
validate_backupdir
sapphrc_backup
cd "$HOME/.config/sapphrc/backups"
gs="$(git status | grep -i 'modified')"
git fetch origin
reslog=$(git log HEAD..origin/main --oneline)
if [[ "${reslog}" != "" ]];then
#remote changes exist
sapphrc_restore
fi
sapphrc_push
}

View file

@ -1 +1 @@
1.2.2
1.3.0

View file

@ -1,68 +1,38 @@
#!/bin/bash
source /lib/sapphrc/sapphrc-functions
COMMAND="${1}"
VERSION=$(cat /lib/sapphrc/version)
setup() {
sapphrc_setup $@
}
profile() {
sapphrc_profile $@
}
backup() {
sapphrc_backup $@
}
restore() {
sapphrc_restore $@
}
updown() {
sapphrc_updown $@
}
push() {
sapphrc_push $@
}
include(){
sapphrc_include $@
}
exclude(){
sapphrc_exclude $@
}
usage() {
echo "Sapphic Package Manager v${VERSION}"
cat /usr/share/doc/sapphrc/sapphrc
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_setup
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_profile
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_backup
sed -e 's/^/ /' /usr/share/doc/sapphrc/sapphrc_restore
}
case $COMMAND in
setup|profile|backup|restore|updown|push|include|exclude )
shift 1;;&
setup )
setup $@;;
profile )
profile $@;;
backup )
backup $@;;
restore )
restore $@;;
updown )
updown $@;;
push )
push $@;;
include )
include $@;;
exclude )
exclude $@;;
setup|profile|backup|restore|sync|include|exclude)
shift 1
;;&
setup)
source /lib/sapphrc/sapphrc-setup
sapphrc_setup
;;
profile)
source /lib/sapphrc/sapphrc-profile
sapphrc_profile $@
;;
backup|restore|sync)
source /lib/sapphrc/sapphrc-sync
;;&
backup)
sapphrc_backup
sapphrc_push
;;
restore)
sapphrc_restore
;;
sync)
sapphrc_sync
;;
include|exclude)
source /lib/sapphrc/sapphrc-filelists
sapphrc_filelists "${COMMAND}" $@
;;
*|usage )
usage;;
esac

View file

@ -1,21 +0,0 @@
#!/bin/bash
source /lib/sapphrc/sapphrc-functions
source /lib/sapphrc/sapphrc-font
validate_backupdir
sapphrc_config="$HOME/.config/sapphrc"
cat "${sapphrc_config}/active_profiles" | while read profile_name
do
backup_homedir="$sapphrc_config/backups/${profile_name}/home"
include_list="$sapphrc_config/backups/${profile_name}/include"
exclude_list="$sapphrc_config/backups/${profile_name}/exclude"
echo "${include_list}"
echo "${exclude_list}"
echo "${HOME}"
echo "${backup_homedir}"
rsync -arvSH --files-from="${include_list}" --exclude-from="${exclude_list}" --exclude '.config/sapphrc/' "${HOME}" "${backup_homedir}"
done
find ${HOME}/.config/sapphrc/backups/ -name *.swp -type f -exec rm {} \;

View file

@ -1,36 +0,0 @@
#!/bin/bash
COMMAND=$1
source /lib/sapphrc/sapphrc-functions
source /lib/sapphrc/sapphrc-font
inex="exclude"
case $COMMAND in
add|remove )
shift 1;;&
add )
action="add";;
remove )
action="remove";;
* )
usage
exit 1;;
esac
while getopts 'hp:' flag; do
case "${flag}" in
p ) echo "${OPTARG}";shift 2;profile_name="${OPTARG}";;&
h ) usage;exit 1 ;;
esac
done
validate_backupdir
case "${action}" in
add )
inex_func "$@";;
remove )
inex_rm "$@";;
esac

View file

@ -1,36 +0,0 @@
#!/bin/bash
COMMAND=$1
source /lib/sapphrc/sapphrc-functions
source /lib/sapphrc/sapphrc-font
inex="include"
case $COMMAND in
add|remove )
shift 1;;&
add )
action="add";;
remove )
action="remove";;
* )
usage
exit 1;;
esac
while getopts 'hp:' flag; do
case "${flag}" in
p ) echo "${OPTARG}";shift 2;profile_name="${OPTARG}";;&
h ) usage;exit 1 ;;
esac
done
validate_backupdir
case "${action}" in
add )
inex_func "$@";;
remove )
inex_rm "$@";;
esac

View file

@ -1,74 +0,0 @@
#!/bin/bash
source /lib/sapphrc/sapphrc-functions
source /lib/sapphrc/sapphrc-font
COMMAND="${1}"
sapphrc_config="${HOME}/.config/sapphrc"
create(){
mkdir -p "${sapphrc_profile_rcdir}"
touch "${sapphrc_profile}/"{include,exclude}
echo '#!/bin/bash'|tee "${sapphrc_profile_rc}" > /dev/null
echo ".sapphrc/${profile_name}"|tee "${sapphrc_profile}/include" > /dev/null
chmod +x "${sapphrc_profile_rc}"
echo "Successfully created '${profile_name}'"
join "${profile_name}"
}
remove(){
echo "WARNING: really remove profile '${profile_name}'?"
echo "~${sapphrc_profile#$HOME} and all its contents will be deleted!"
read -p "Confirm removal (y/N): " confirm_remove
if [[ "${confirm_remove}" =~ ^([yY][eE][sS]|[yY])$ ]];then
leave
echo "removing '${profile_name}'"
rm -r "${sapphrc_profile}"
echo "Profile '${profile_name}' has been removed. Be sure to leave the profile on other machines/accounts to avoid synchronization issues."
fi
}
join(){
if grep -q ^"${profile_name}"$ "${sapphrc_config}/active_profiles";then
echo "Already joined ${profile_name}, nothing to do."
else
echo "${profile_name}"|tee -a "${sapphrc_config}/active_profiles" > /dev/null
echo "Successfully joined '${profile_name}'!"
fi
}
leave(){
if grep -q ^"${profile_name}"$ "${sapphrc_config}/active_profiles";then
sed -i '/^'"${profile_name}"'$/d' "${sapphrc_config}/active_profiles"
[ -e "${HOME}/.sapphrc/${profile_name}" ] && rm "${HOME}/.sapphrc/${profile_name}"
echo "Successfully left '${profile_name}'!"
else
echo "You have not joined '${profile_name}', nothing to do."
fi
}
list(){
echo "${bold}Active profiles:${normal}"
cat "${sapphrc_config}/active_profiles"
echo "${bold}Available profiles:${normal}"
ls "${sapphrc_config}/backups/" | cat
}
case $COMMAND in
create|remove|join|leave )
validate_backupdir;shift 1;
validate_profile $@;;&
create )
create $@;;
remove )
remove $@;;
join )
join $@;;
leave )
leave $@;;
list )
list;;
*|usage )
usage;;
esac

View file

@ -1,11 +0,0 @@
#!/bin/bash
source /lib/sapphrc/sapphrc-functions
source /lib/sapphrc/sapphrc-font
validate_backupdir
cd "$HOME/.config/sapphrc/backups"
git add .;
git add -u;
git commit -m "New backup `date +'%Y-%m-%d %H:%M:%S'`";
git push origin main

View file

@ -1,19 +0,0 @@
#!/bin/bash
source /lib/sapphrc/sapphrc-functions
source /lib/sapphrc/sapphrc-font
validate_backupdir
cd "$HOME/.config/sapphrc/backups"
git config pull.rebase false
git pull --no-edit
sapphrc_config="$HOME/.config/sapphrc"
cat "${sapphrc_config}/active_profiles" | while read profile_name
do
backup_homedir="$sapphrc_config/backups/${profile_name}/home"
include_list="$sapphrc_config/backups/${profile_name}/include"
exclude_list="$sapphrc_config/backups/${profile_name}/exclude"
rsync -arvSH --files-from="${include_list}" --exclude-from="${exclude_list}" --exclude '.config/sapphrc/' "${backup_homedir}" "${HOME}"
done

View file

@ -1,65 +0,0 @@
#!/bin/bash
sapphrc_config="$HOME/.config/sapphrc"
if [ -f "${aspphic_config}/backups/.init_complete" ];then
echo "already setup"
exit 0
fi
mkdir -p "${sapphrc_config}"
mkdir -p "${HOME}/.sapphrc"
while true;do
read -p "pull from an existing backup repo? (y/n) " gitrepo_exists
case $gitrepo_exists in
[Yy] )
read -p "Enter YOUR git repo url: " git_url
git clone "${git_url}" "${sapphrc_config}/backups"
touch "${sapphrc_config}/backups/.init_complete"
backup_count="0"
backups=($(ls "${sapphrc_config}/backups/"))
for b in ${backups[@]};do
[ -d "${sapphrc_config}/backups/${b}" ] && backup_count=$(($backup_count+1))
done
if [[ backup_count -gt 0 ]];then
read -p "Found existing profile(s). Join one? (Y/n) " yn
[[ "${yn}" =~ ^([nN][oO]|[nN])$ ]] || sapphrc profile join
else
sapphrc profile create default
fi
break
;;
[Nn] )
mkdir -p "${sapphrc_config}/backups"
cd "${sapphrc_config}/backups"
git init
touch "${sapphrc_config}/backups/.init_complete"
git add .
git commit -m "first commit"
git branch -M main
read -p "Enter YOUR git repo url: " git_url
git remote add origin "${git_url}"
git push -u origin main
break
;;
esac
done
##link ~/.sapphrc/* files to .bashrc
sapphrc_bashrc="$(awk '/.sapphrc/,/done/' ~/.bashrc)"
if [[ "${#sapphrc_bashrc}" -eq 0 ]];then
echo "for file in ~/.sapphrc/* ; do" >> $HOME/.bashrc
echo " if [ -f \""'$file'"\" ] ; then" >> $HOME/.bashrc
echo " source \""'$file'"\"" >> $HOME/.bashrc
echo " fi" >> $HOME/.bashrc
echo "done" >> $HOME/.bashrc
fi
if [ ! "$(crontab -l | grep -i 'sapphrc_updown')" ];then
mkdir -p $HOME/.cache/sapphrc/
crontab -l > $HOME/.cache/sapphrc/crontab
echo "*/15 * * * * sapphrc_updown" >> $HOME/.cache/sapphrc/crontab
crontab $HOME/.cache/sapphrc/crontab
rm $HOME/.cache/sapphrc/crontab
fi

View file

@ -1,18 +0,0 @@
#!/bin/bash
source /lib/sapphrc/sapphrc-functions
source /lib/sapphrc/sapphrc-font
validate_backupdir
cd "$HOME/.config/sapphrc/backups"
sapphrc_backup
gs="$(git status | grep -i 'modified')"
git fetch origin
reslog=$(git log HEAD..origin/main --oneline)
if [[ "${reslog}" != "" ]];then
#remote changes exist
sapphrc_restore
fi
sapphrc_push
exit

View file

@ -1,6 +1,6 @@
Usage: spm command [options]
Usage: sapphrc command [options]
Sapphrc is a dotfiles manager with support for multiple profile and git synchonization
Sapphrc is a dotfiles manager with support for multiple profiles and git synchonization
Commands:
usage: Print this dialogue

View file

@ -1,3 +0,0 @@
backup: update profile based on current configuration
usage:
sapphrc exclude [action] (-p )

View file

@ -0,0 +1,7 @@
include/exclude: manage list of files to be included or excluded from a backup, respectively
usage:
sapphrc [include|exclude] add (-p profile_name) /path/to/file /add/multiple/files
sapphrc [include|exclude] remove (-p profile_name)
actions:
add: adds user-defined files/directories to the include/exclude list
remove: prompts user to select which files to remove from the include/exclude list

View file

@ -1 +0,0 @@
include

View file

@ -6,3 +6,4 @@ profile: manage sapphrc profiles
remove: leaves and deletes an existing sapphrc profile
join: joins an existing sapphrc profile
leave: leaves an existing sapphrc profile
list: lists profiles

View file

@ -0,0 +1,3 @@
setup: Initializes sapphrc
usage:
sapphrc setup

View file

@ -0,0 +1,3 @@
sync: Attempts to neatly back up local changes and restore remote changes
usage:
sapphrc sync